/* the DS1621 I2C bus is connected to PORTC */

/* the SDA signal is bit 3 */

/* the SCL signal is bit 4 */

#asm

    .equ __i2c_port=0x15

    .equ __sda_bit=3

    .equ __scl_bit=4

#endasm

/* include the DS1621 Functions */

#include <ds1621.h>

/* the LCD module is connected to PORTB */

#asm

    .equ __lcd_port=0x18

#endasm

/* include the LCD Functions */

#include <lcd.h>

/* include the prototype for sprintf */

#include <stdio.h>

/* include the prototype for abs */

#include <math.h>

char display_buffer[33];

void main(void) {

int t0,t1;

/* initialize the LCD, 2 rows by 16 columns */

lcd_init(16);

/* initialize the I2C bus */

i2c_init();

/* initialize the DS1621 sensor with address 0 */

/* tlow=20C thigh=25C */

ds1621_init(0,20,25,0);

/* initialize the DS1621 sensor with address 1 */

/* tlow=30C thigh=35C */

ds1621_init(1,30,35,0);

/* temperature display loop */

while (1)
	{
	/* read the temperature of DS1621 #0 *10C */
	t0=ds1621_temperature_10(0);

	/* read the temperature of DS1621 #1 *10C */
	t1=ds1621_temperature_10(1);

	/* prepare the displayed temperatures */
	/* in the display_buffer */
	sprintf(display_buffer,
	"t0=%-i.%-u%cC\nt1=%-i.%-u%cC",
	t0/10,abs(t0%10),0xdf,t1/10,abs(t1%10),0xdf);

	/* display the temperatures */
	lcd_clear();
	lcd_puts(display_buffer);
	};
}